#include <allegro.h>
#include "./data.h"
#include "./engine.h"

BITMAP *buffer;
BITMAP *secret_b;
DATAFILE *dat;

volatile int fps;
volatile int lfps;
volatile int game_time;

void intro()
{
    play_midi((MIDI *)dat[TITLE_SONG].dat, 1);
    char *text0="BAFSoft Presents";
    char *text0_1="For the TINS 2003 Compo";
    char *text0_2="Drunk Jello!";
    char *text1="Once upon a time, on a reddish,";
    char *text1_1="rusty planet called \"Mars\"";
    char *text2="There was a very odd ordeal.";
    char *text2_1="The ordeal involved drunk men";
    char *text3="These men were on Earth one day";
    char *text3_1="when they ate THE \"Alcoholic Jello\"!";
    char *text4="They got very drunk, as they ate";
    char *text4_1="batches and batches of it!";
    char *text5="They somehow end up on Mars, with";
    char *text5_1="all the alcohol in their system";
    char *text6="So they need YOUR help to find the";
    char *text6_1="precious....";
    
    char *secret ="H 0";
    char *secretu=" 2";
    text_mode(-1);
    secret_b=create_bitmap(text_length(font, secret), text_height(font)*2);
    clear_to_color(secret_b, makecol(255,0,255));
    clear_to_color(screen, makecol(128, 45, 0));
    textout(secret_b, font, secret, 0, 1, makecol(0,69,0));
    textout(secret_b, font, secretu, 0, text_height(font)/2, makecol(0,69,0));
    
    rest(500);
    //while(!keypressed())
    //{
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text0, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text0_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text0_2, SCREEN_W/2, SCREEN_H/2+2*text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text1, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text1_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        //rest(500);
        textout_centre(screen, (FONT *)dat[INTRO].dat, text2, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text2_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));    
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text3, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text3_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text4, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text4_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text5, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text5_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text6, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text6_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(3000);
    
        for(int i=0; i<5; i++)
        {
            clear_to_color(screen, makecol(92,128,192));
            rest(500);
            draw_sprite(screen, secret_b, SCREEN_W/2-secret_b->w/2, SCREEN_H/2);
            rest(500);
        }
        //break;
    //}
    
    clear_to_color(screen, makecol(0,0,0));
}

void menu()
{
    char *newtxt="Play/Continue";
    char *highscoretxt="High Scores";
    char *exittxt="Exit";
    bool done=false;
    bool do_blit=true;
    while(!done)
    {
        clear_to_color(buffer, makecol(0,0,0));
        
        textprintf_centre(buffer, (FONT *)dat[TITLE].dat, SCREEN_W/2, 10, makecol(255,63,134), "~Drunk Jello~");
        
        rectfill(buffer, SCREEN_W/2-50, SCREEN_H/2-36, SCREEN_W/2+50, SCREEN_H/2-60, makecol(192,192,192));
        textout_centre(buffer, font, newtxt, SCREEN_W/2, SCREEN_H/2-48, makecol(0,0,0));
        rectfill(buffer, SCREEN_W/2-50, SCREEN_H/2-12, SCREEN_W/2+50, SCREEN_H/2+12, makecol(192,192,192));
        textout_centre(buffer, font, highscoretxt, SCREEN_W/2, SCREEN_H/2, makecol(0,0,0));
        rectfill(buffer, SCREEN_W/2-50, SCREEN_H/2+36, SCREEN_W/2+50, SCREEN_H/2+60, makecol(192,192,192));
        textout_centre(buffer, font, exittxt, SCREEN_W/2, SCREEN_H/2+48, makecol(0,0,0));        
        
        textprintf_centre(buffer, (FONT *)dat[TITLE].dat, SCREEN_W/2, SCREEN_H-text_height((FONT *)dat[TITLE].dat)-10, makecol(255,63,134), "BAFSoft :: TINS 2003");
        
        draw_sprite(buffer, mouse_sprite, mouse_x, mouse_y);
        if(do_blit)
            blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
        if(mouse_b & 1)
        {
            if(mouse_x>SCREEN_W/2-50 && mouse_x<SCREEN_W/2+50)
            {
                if(mouse_y>SCREEN_H/2-60 && mouse_y<SCREEN_H/2-26)
                {
                    //new game
                    do_blit=false;
                    start_timers();
                    //load_map(NULL);
                    //main_loop();
                    test_blit();
                    do_blit=true;
                    //newgame();
                }
                if(mouse_y<SCREEN_H/2+12 && mouse_y>SCREEN_H/2-12)
                {
                    //highscores
                    //hsdisp();
                }
                if(mouse_y<SCREEN_H/2+60 && mouse_y>SCREEN_H/2+26)
                {
                    //exit
                    done=true;
                }
            }
        }
    }
}

void greetz()
{
    stop_midi();
    play_midi((MIDI *)dat[TITLE_SONG].dat, 1);
    char *text0="BAFSoft Thanks";
    char *text0_1="AND Appreciates";
    char *text0_2="lordnir for doing my bg/sprites,";
    char *text1="Amarillion for TINS,";
    char *text1_1="A rusty planet called \"Mars\",";
    char *text2="#allegro on EFNet for helping me";
    char *text2_1="with my technical questions,";
    char *text3="Shawn Hargreaves, and the";
    char *text3_1="Allegro community (for Allegro)";
    char *text4="AND Of course:";
    char *text4_1="Everyone i forgot :D";
    
    
    rest(500);
    //while(!keypressed())
    //{
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text0, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text0_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text0_2, SCREEN_W/2, SCREEN_H/2+2*text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text1, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text1_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        //rest(500);
        textout_centre(screen, (FONT *)dat[INTRO].dat, text2, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text2_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));    
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text3, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text3_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        clear_to_color(screen, makecol(128,45,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text4, SCREEN_W/2, SCREEN_H/2-text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        textout_centre(screen, (FONT *)dat[INTRO].dat, text4_1, SCREEN_W/2, SCREEN_H/2+text_height((FONT *)dat[INTRO].dat), makecol(0,0,0));
        rest(5000);
        unload_datafile(dat);
        allegro_exit();
}

int main(int argc, char *args)
{
    allegro_init();
    install_keyboard();
    install_timer();
    install_mouse();
    install_joystick(JOY_TYPE_AUTODETECT);
    install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
    set_color_depth(24);
    if(set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) != 0)
    {
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        allegro_message("Error setting graphics mode :O:\n\"%s\"", allegro_error);
        allegro_exit();
        return -1;
    }
    LOCK_VARIABLE(fps);
    LOCK_VARIABLE(lfps);
    LOCK_VARIABLE(time);
    LOCK_FUNCTION(fps_timer);
    LOCK_FUNCTION(game_timer);
    buffer=create_bitmap(SCREEN_W, SCREEN_H);
    dat=load_datafile("./data.dat");
    load_tiles();
    intro();
    //text_mode(-1);
    menu();
    greetz();
}
END_OF_MAIN()